--EMP
--By Teta_Bonita/KeksMan

AddCSLuaFile('cl_init.lua')
AddCSLuaFile('shared.lua')
include('shared.lua')

local Model = "models/props_wasteland/laundry_washer003.mdl"



function ENT:SpawnFunction(ply, tr)

	if not tr.Hit then return end

	local SpawnPos = tr.HitPos + tr.HitNormal*16
	local ent = ents.Create("sent_EMP")
	ent:SetPos(SpawnPos)
	ent:SetVar("Owner",ply)
	ent:Spawn()
	ent:Activate()
	return ent

end



function ENT:Initialize()

	self.Entity:SetModel(Model)

	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)	
	self.Entity:SetSolid(SOLID_VPHYSICS)

	local phys = self.Entity:GetPhysicsObject()
	if phys:IsValid() then
	if not (WireAddon == nil) then self.Inputs = Wire_CreateInputs(self.Entity, { "Detonate!"}) end	
		phys:Wake()
	end
	
	self.Position = Vector()
	self.Activated = false
	self.Exploding = false
	self.IsEMP = true
	self.Integrity = 1


end


function ENT:TriggerInput(iname, value) --wire inputs
	if (iname == "Detonate!") then
		if value == 1 then
		       	self.Activated = true
			self.Exploding = true
			self.Position = self.Entity:GetPos()
			self:ChainReaction(1)
			end
		end
	end

function ENT:ChainReaction(lastpower)

if not self.Exploding then return end

local BoomPower = 5

	for key,found in pairs(ents.FindInSphere(self.Position,1)) do
		if found:GetVar("IsEMPfalse") and found ~= self.Entity then
			found:SetVar("Activated",true)
			found:SetVar("Exploding",false)
			found:Remove()
			BoomPower = 5
		end
	end

	if BoomPower <= 6 then
		self:Detonate(BoomPower)
	else
		self:ChainReaction(BoomPower)
	end
	



end

function ENT:Detonate(power)

	if not self.Exploding or not self.Entity then return end

	local Boom = ents.Create("sent_explosion_scaleableEMP")
	Boom:SetPos(self.Position)
	Boom:SetVar("Owner",self.Owner)
	Boom:SetVar("Scale",power)
	Boom:SetAngles(self.Entity:GetAngles())
	Boom:Spawn()
	self.Entity:Remove()
end


function ENT:PhysicsCollide( data, physobj )
   	    if data.Speed > 300 and data.DeltaTime > 0.15 then -- if it hits an object at over 600 speed
        			self.Activated = true
			self.Exploding = true
	   			self.Position = self.Entity:GetPos()
			self:ChainReaction(1)

		end
end


function ENT:OnTakeDamage(dmginfo)

if self.Activated then return end

	self.Integrity = self.Integrity - dmginfo:GetDamage()
		if self.Integrity <= 0 then
			self.Activated = true
			self.Exploding = true
			self.Owner = dmginfo:GetAttacker()
			self.Position = self.Entity:GetPos()
			self:ChainReaction(1)
		end

	self.Entity:TakePhysicsDamage(dmginfo)
	
end


function ENT:Use(activator, caller)

end

function ENT:Think()

end

function ENT:OnRemove()

end




