--Breaching Charge
--By Teta_Bonita/KeksMan

AddCSLuaFile('cl_init.lua')
AddCSLuaFile('shared.lua')
include('shared.lua')


local Model = "models/Items/car_battery01.mdl" --Alternate model



function ENT:SpawnFunction(ply, tr)

	if not tr.Hit then return end

	local SpawnPos = tr.HitPos + tr.HitNormal*16
	local ent = ents.Create("sent_BR")
	ent:SetPos(SpawnPos)
	ent:SetVar("Owner",ply)
	ent:Spawn()
	ent:Activate()
	return ent

end



function ENT:Initialize()

	self.Entity:SetModel(Model)

	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)	
	self.Entity:SetSolid(SOLID_VPHYSICS)

	local phys = self.Entity:GetPhysicsObject()
	if phys:IsValid() then
	if not (WireAddon == nil) then self.Inputs = Wire_CreateInputs(self.Entity, { "Detonate!"}) end	
		phys:Wake()
	end
	
	self.Position = Vector()
	self.Activated = false
	self.Exploding = false
	self.IsBR = true
	self.Integrity = 1


end


function ENT:TriggerInput(iname, value) --wire inputs
	if (iname == "Detonate!") then
		if value == 1 then
		       	self.Activated = true
			self.Exploding = true
			self.Position = self.Entity:GetPos()
			self:ChainReaction(1)
			end
		end
	end

function ENT:ChainReaction(lastpower)

if not self.Exploding then return end

local BoomPower = 0

	for key,found in pairs(ents.FindInSphere(self.Position,0)) do
		if found:GetVar("IsBR",false) and found ~= self.Entity then
			found:SetVar("Activated",true)
			found:SetVar("Exploding",false)
			--found:Remove()
		end
	end

	if BoomPower <= lastpower then
		self:Detonate(BoomPower)
	else
		self:ChainReaction(BoomPower)
	end
	
end

function ENT:Detonate(power)

	if not self.Exploding or not self.Entity then return end

	local Boom = ents.Create("sent_explosion_scaleableBR")
	Boom:SetPos(self.Position)
	Boom:SetVar("Owner",self.Owner)
	Boom:SetVar("Scale",power)
	Boom:SetAngles(self.Entity:GetAngles())
	Boom:Spawn()
	
	self.Entity:Remove()
	
	for _, v in pairs(ents.FindInSphere( self.Entity:GetPos(), 25 )) do  
     v:Fire("enablemotion","",0)
     constraint.RemoveAll( v ) 

	end
	local physExplo = ents.Create( "env_physexplosion" )
	physExplo:SetOwner( self.Owner )
        physExplo:SetPos( self.Entity:GetPos() + Vector(0,0,20))
        physExplo:SetKeyValue( "Magnitude", "9999" )	-- Power of the Physicsexplosion
        physExplo:SetKeyValue( "radius", "150" )	-- Radius of the explosion
        physExplo:SetKeyValue( "spawnflags", "19" )
        physExplo:Spawn()
        physExplo:Fire( "Explode", "", 0 )
end

function ENT:PhysicsCollide(data, physobj)


end


function ENT:OnTakeDamage(dmginfo)

if self.Activated then return end

	self.Integrity = self.Integrity - dmginfo:GetDamage()
		if self.Integrity <= 0 then
			self.Activated = true
			self.Exploding = true
			self.Owner = dmginfo:GetAttacker()
			self.Position = self.Entity:GetPos()
			self:ChainReaction(1)
		end

	self.Entity:TakePhysicsDamage(dmginfo)
	
	self.Integrity = self.Integrity - dmginfo:GetDamage()
		if self.Integrity <= 0 then
			self.Activated = true
			self.Exploding = true
			self.Position = self.Entity:GetPos()
			self:ChainReaction(1)
		end
end


function ENT:Use(activator, caller)

end

function ENT:Think()

end

function ENT:OnRemove()

end




